# node typescript parser

This package is a TypeScript and ECMAScript parser. It uses the underlying typescript parser to generate
a more or less human readable AST out of .js or .ts files.

[![npm](https://img.shields.io/npm/v/browser-typescript-parser.svg?maxAge=3600)](https://www.npmjs.com/package/browser-typescript-parser)
[![Commitizen friendly](https://img.shields.io/badge/commitizen-friendly-brightgreen.svg)](http://commitizen.github.io/cz-cli/)
[![semantic-release](https://img.shields.io/badge/%20%20%F0%9F%93%A6%F0%9F%9A%80-semantic--release-e10079.svg)](https://github.com/semantic-release/semantic-release)
[![codecov](https://codecov.io/gh/yousifalraheem/browser-typescript-parser/branch/master/graph/badge.svg)](https://codecov.io/gh/yousifalraheem/browser-typescript-parser)

## How to use

### [View Source Docs](https://yousifalraheem.github.io/browser-typescript-parser/)

You can use the parser with:

```typescript
const parser = new TypescriptParser();

const parsed = await parser.parseSource(/* typescript source code as string */);
```

You can also parse multiple files at ones.

To use the declaration index (which is basically a list of symbols for your files)
instantiate an index first and throw him some files.

After the parsing is done, you'll get an index with resolved
exports and declarations.

Keep in mind, that the index'll only contain exported declarations.

## Changelog

The changelog is generated by [semantic release](https://github.com/semantic-release/semantic-release) and is located under the
[release section](https://github.com/yousifalraheem/browser-typescript-parser/releases).

## Licence

This software is licenced under the [MIT](LICENSE) licence.
