"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMethodDeclaration = void 0;
var DeclarationVisibility_1 = require("../../declarations/DeclarationVisibility");
var parameterDeclaration_1 = require("./parameterDeclaration");
/**
 * Generates typescript code for a method declaration.
 *
 * @export
 * @param {MethodDeclaration} method
 * @param {TypescriptGenerationOptions} { tabSize }
 * @returns {string}
 */
function generateMethodDeclaration(method, _a) {
    var tabSize = _a.tabSize;
    var intend = Array(tabSize + 1).join(' ');
    return "".concat(intend) +
        "".concat(method.visibility !== undefined ? (0, DeclarationVisibility_1.getVisibilityText)(method.visibility) + ' ' : '').concat(method.name, "(") +
        "".concat(method.parameters.map(function (o) { return (0, parameterDeclaration_1.generateParameterDeclaration)(o); }).join(', '), ")") +
        "".concat(method.type ? ": ".concat(method.type) : '', " {\n").concat(intend).concat(intend, "throw new Error('Not implemented yet.');\n").concat(intend, "}\n");
}
exports.generateMethodDeclaration = generateMethodDeclaration;
