"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatePropertyDeclaration = void 0;
var DeclarationVisibility_1 = require("../../declarations/DeclarationVisibility");
/**
 * Generates typescript code for a class property.
 *
 * @export
 * @param {PropertyDeclaration} property
 * @param {TypescriptGenerationOptions} { tabSize }
 * @returns {string}
 */
function generatePropertyDeclaration(property, _a) {
    var tabSize = _a.tabSize;
    return "".concat(Array(tabSize + 1).join(' ')) +
        "".concat(property.visibility !== undefined ? (0, DeclarationVisibility_1.getVisibilityText)(property.visibility) + ' ' : '') +
        "".concat(property.name).concat(property.isOptional ? '?' : '').concat(property.type ? ": ".concat(property.type) : '', ";\n");
}
exports.generatePropertyDeclaration = generatePropertyDeclaration;
