"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayBoundParameterDeclaration = exports.ObjectBoundParameterDeclaration = exports.BoundParameterDeclaration = exports.ParameterDeclaration = void 0;
var tslib_1 = require("tslib");
/**
 * Parameter declaration. Is contained in a method or function delaration since a parameter can not be exported
 * by itself.
 *
 * @export
 * @class ParameterDeclaration
 * @implements {TypedDeclaration}
 */
var ParameterDeclaration = /** @class */ (function () {
    function ParameterDeclaration(_name, _type, start, end) {
        this._name = _name;
        this._type = _type;
        this.start = start;
        this.end = end;
    }
    Object.defineProperty(ParameterDeclaration.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (value) {
            this._name = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ParameterDeclaration.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (value) {
            this._type = value;
        },
        enumerable: false,
        configurable: true
    });
    return ParameterDeclaration;
}());
exports.ParameterDeclaration = ParameterDeclaration;
var BoundParameterDeclaration = /** @class */ (function (_super) {
    tslib_1.__extends(BoundParameterDeclaration, _super);
    function BoundParameterDeclaration(startCharacter, endCharacter, start, end) {
        var _this = _super.call(this, "", "", start, end) || this;
        _this.startCharacter = startCharacter;
        _this.endCharacter = endCharacter;
        _this.parameters = [];
        return _this;
    }
    Object.defineProperty(BoundParameterDeclaration.prototype, "name", {
        get: function () {
            return this.parameters.length
                ? "".concat(this.startCharacter, " ").concat(this.parameters.map(function (p) { return p.name; }).join(", "), " ").concat(this.endCharacter)
                : this.startCharacter + this.endCharacter;
        },
        set: function (_) { },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BoundParameterDeclaration.prototype, "type", {
        get: function () {
            return this.typeReference || this.parameters.length
                ? "{ ".concat(this.parameters.map(function (p) { return p.type; }).join(", "), " }")
                : this.startCharacter + this.endCharacter;
        },
        set: function (_) { },
        enumerable: false,
        configurable: true
    });
    return BoundParameterDeclaration;
}(ParameterDeclaration));
exports.BoundParameterDeclaration = BoundParameterDeclaration;
var ObjectBoundParameterDeclaration = /** @class */ (function (_super) {
    tslib_1.__extends(ObjectBoundParameterDeclaration, _super);
    function ObjectBoundParameterDeclaration(start, end) {
        return _super.call(this, "{", "}", start, end) || this;
    }
    return ObjectBoundParameterDeclaration;
}(BoundParameterDeclaration));
exports.ObjectBoundParameterDeclaration = ObjectBoundParameterDeclaration;
var ArrayBoundParameterDeclaration = /** @class */ (function (_super) {
    tslib_1.__extends(ArrayBoundParameterDeclaration, _super);
    function ArrayBoundParameterDeclaration(start, end) {
        return _super.call(this, "[", "]", start, end) || this;
    }
    return ArrayBoundParameterDeclaration;
}(BoundParameterDeclaration));
exports.ArrayBoundParameterDeclaration = ArrayBoundParameterDeclaration;
